precision highp float;


uniform sampler2D tex;
uniform float alpha_mult;
uniform vec2 iResolution;
uniform float iGlobalTime_lo;
uniform float iGlobalTime_hi;
varying vec2 tex_coord;

float iGlobalTime;

float rgb(float p, float q, float t) {
 if( t< 0.0) t+= 1.0;
 if( t> 1.0) t-= 1.0;
 if( t< (1.0/6.0)) return p+ (q-p)*6.0*t;
 if( t< (1.0/2.0)) return q;
 if( t< (2.0/3.0)) return p+(q-p) * ((2.0/3.0) - t) * 6.0;
 return p;
}

void main(void) {
 vec4 c;
 float h, s, l;
 float q, p;

 iGlobalTime = iGlobalTime_lo + iGlobalTime_hi;

 c.a =texture2D(tex, tex_coord.st).a;
 
 s = 1.0;
 l = 0.5;

 q = l < 0.5 ? l * (1.0+s) : l+s-l*s;
 p = 2.0*l-q;

 h = mod(((gl_FragCoord.x/ (iResolution.x*2.0))+iGlobalTime/10.0), 1.0);
 
 c.r = rgb(p,q,h+(1.0/3.0));
 c.g = rgb(p,q,h);
 c.b = rgb(p,q,h-(1.0/3.0)); 

 gl_FragColor = c;
}

