precision highp float;

uniform sampler2D tex;
uniform sampler2D alpha_tex;
uniform float alpha_mult;
uniform float iGlobalTime_hi;
uniform float iGlobalTime_lo; 
varying vec2 tex_coord;

float iGlobalTime;

vec2 frag_coord;
const float divs = 12.0;
const vec2 iResolution = vec2(1.0,1.0);

float sphere_no;

const int rays_hits=9;
const float epsilon=0.001;
vec3 vertical=vec3(sin(0.8*iGlobalTime),1.0,0.0);

vec3 sphere1=vec3(-2.0,-2.0,-2.0);
vec3 sphere2=vec3(2.0,-2.0,-2.0);
vec3 sphere3=vec3(2.0,2.0,-2.0);
vec3 sphere4=vec3(-2.0,2.0,-2.0);

vec3 sphere5=vec3(-2.0,-2.0,2.0);
vec3 sphere6=vec3(2.0,-2.0,2.0);
vec3 sphere7=vec3(2.0,2.0,2.0);
vec3 sphere8=vec3(-2.0,2.0,2.0);







vec3 back(vec3 rd)
{
	float s= rd.y;//pow(dot(rd,vertical),0.68);//Sky
	float f= dot(rd,vec3(0.0));//floor
	vec3 sc=s*vec3(255./255.,255./255.,255./255.);
	vec3 fc=f*vec3(66.0/255.0,111.0/255.0,169.0/255.0);
	return sc * vec3(66.0/255.0,111.0/255.0,169.0/255.0); //max(sc,fc);
}



vec3 sphere(vec3 ray, vec3 dir, vec3 center, float radius, vec3 closed_hit, out vec3 normal, float count)
{
  vec3 rc = ray-center;
  float c = dot(rc, rc) - (radius*radius);
  float b = dot(dir, rc);
  float d = b*b - c;
  float t = -b - sqrt(abs(d));
  if (d < 0.0 || t < 0.0 || t > closed_hit.x) { 
	return closed_hit;
  } else {
    normal = center-(ray+dir*t);
    return vec3(t, radius, count);
 }
 
}


vec3 scene(vec3 ro, vec3 rd, out vec3 normal, float max_dist)
{
	vec3 dist;
        dist.x=max_dist;
        dist.y=(cos(iGlobalTime+0.15)*(1.8/2.0))+(1.8/2.0);

	dist=sphere(ro,rd,sphere1,(cos(iGlobalTime+0.15)*(1.8/2.0))+(1.8/2.0),dist,normal, 1.0);
	dist=sphere(ro,rd,sphere2,(cos(iGlobalTime+(0.15))*(1.8/2.0))+(1.8/2.0),dist,normal, 2.0);
	dist=sphere(ro,rd,sphere3,(cos(iGlobalTime+(0.15))*(1.8/2.0))+(1.8/2.0),dist,normal, 3.0);
	dist=sphere(ro,rd,sphere4,(cos(iGlobalTime+(0.15))*(1.8/2.0))+(1.8/2.0),dist,normal, 4.0);

	dist=sphere(ro,rd,sphere5,(cos(iGlobalTime+(0.15))*(1.8/2.0))+(1.8/2.0),dist,normal, 5.0);
	dist=sphere(ro,rd,sphere6,(cos(iGlobalTime+(0.15))*(1.8/2.0))+(1.8/2.0),dist,normal, 6.0);
	dist=sphere(ro,rd,sphere7,(cos(iGlobalTime+(0.15))*(1.8/2.0))+(1.8/2.0),dist,normal, 7.0);
	dist=sphere(ro,rd,sphere8,(cos(iGlobalTime+(0.15))*(1.8/2.0))+(1.8/2.0),dist,normal, 8.0);




	return dist;
}

mat4 rotationMatrix(vec3 axis, float angle) {
 axis = normalize(axis);
 float s = sin(angle);
 float c = cos(angle);
 float oc = 1.0 - c;
    
 return mat4(
  oc * axis.x * axis.x + c,          
  oc * axis.x * axis.y - axis.z * s,  
  oc * axis.z * axis.x + axis.y * s, 
  0.0,
  oc * axis.x * axis.y + axis.z * s, 
  oc * axis.y * axis.y + c,    
  oc * axis.y * axis.z - axis.x * s,  
  0.0,
  oc * axis.z * axis.x - axis.y * s,  
  oc * axis.y * axis.z + axis.x * s,
  oc * axis.z * axis.z + c,    
  0.0, 
  0.0, 
  0.0, 
  0.0,
  1.0);
}



mat2 rotate2D(float a)
{
	return mat2(cos(a), -sin(a),
				sin(a),  cos(a));
}

vec2 rotateY(vec2 v, float a)
{
	return v*rotate2D(a);
}

void main( void )
{
 float dist;
 vec3  retter;
 vec2 sphere_tex_coord;
 iGlobalTime = iGlobalTime_hi+iGlobalTime_lo;

 frag_coord.xy = tex_coord.st;



    vec2 v = (-1.0 + 2.0*frag_coord.xy / iResolution.xy);
	vec4 light = vec4(0.0);    
	vec3 transmit = vec3(1.0); 
	vec3 ro=vec3(1.0*cos(iGlobalTime),0.0,2.0*sin(iGlobalTime))+vertical;   
	vec2 vd=normalize(vec3(0.0,0.0,0.0) - ro).xz; //view direction
	float va=atan(vd.y,vd.x);

	vec2 r2d=rotateY(vec2(1.0,v.x),va);
              

 

        vec3 rd=normalize(vec3(r2d.x,v.y,r2d.y));    //direction 
	for (int r=0;r < rays_hits; r++)
	{
		vec3 normal;
		float max_dist=1000.0;
		retter=scene(ro,rd,normal,max_dist);
                dist = retter.x;
 

                 
		if (dist < max_dist)
		{
			
			transmit*=0.9;
			ro += rd*dist;
			rd =reflect(rd,normalize(normal));
			ro += rd*epsilon; 
			

			if(retter.z == 1.0) light=vec4(1.0, 0.0, 0.0, 1.0);
                	if(retter.z == 2.0) light=vec4(0.0, 1.0, 0.0, 1.0);
               		if(retter.z == 3.0) light=vec4(0.0, 0.0, 1.0, 1.0);
               		if(retter.z == 4.0) light=vec4(1.0, 1.0, 0.0, 1.0);
               		if(retter.z == 5.0) light=vec4(0.0, 1.0, 1.0, 1.0);
               		if(retter.z == 6.0) light=vec4(1.0, 0.0, 1.0, 1.0);
               		if(retter.z == 7.0) light=vec4(0.0, 0.0, 2.0, 1.0);
               		if(retter.z == 8.0) light=vec4(0.0, 1.0, 0.0, 1.0);
                       


			vec3 Vn, Vp, Ve;
		        Vn = normalize(vec3(0.0, retter.y, 0.0));
			Vp = normalize(normal);
			Ve = normalize(vec3(retter.y, 0.0, retter.y));

 
			float phi = acos( -dot(Vn,Vp));
                        float v = phi/3.141592;

	                float theta = ( acos(dot(Vp,Ve) / sin(phi))) / (2.0*3.141592);
	

			float what = 1.0;
                        float du;	
                        if(dot(cross(Vn,Ve), Vp) > 0.0)
                         du = theta;
			else
                	 du = what - theta;

	
                        sphere_tex_coord.st = vec2(v, du);
                        light.rgb *= texture2D(tex, sphere_tex_coord.st).rgb;

		}
		else { //hit infinite (or default object)
			light.rgb += transmit*back(rd); //here background fonction
                    

			break;
		}
	}

 float alpha = texture2D(alpha_tex, tex_coord.st).r;
 gl_FragColor = vec4(light.rgb, light.a * alpha);

}


