precision highp float;


uniform sampler2D tex;
uniform sampler2D alpha_tex;
uniform float alpha_mult;
uniform vec2 iResolution;
uniform float iGlobalTime_lo;
uniform float iGlobalTime_hi;
varying vec2 tex_coord;

float iGlobalTime;

float rgb(float p, float q, float t) {
 if( t< 0.0) t+= 1.0;
 if( t> 1.0) t-= 1.0;
 if( t< (1.0/6.0)) return p+ (q-p)*6.0*t;
 if( t< (1.0/2.0)) return q;
 if( t< (2.0/3.0)) return p+(q-p) * ((2.0/3.0) - t) * 6.0;
 return p;
}

void main(void) {
 float h, s, l;
 float q, p;
 vec2 uv;
 vec3 cc;

 iGlobalTime = iGlobalTime_lo + iGlobalTime_hi;


 uv = gl_FragCoord.xy/(iResolution.xy);
 
// cc.a = 1.0; //cc.a =texture2D(tex, tex_coord.st).a;
 
 s = 1.0;
 l = 0.5;

 

 h = length(uv.st - (-1.0 *vec2((266.0/(1280.0)),(110.0f/800.0f))));
 h+=iGlobalTime/20.0;
 h=mod(h,1.0);

 q = l < 0.5 ? l * (1.0+s) : l+s-l*s;
 p = 2.0*l-q;


// s = length(uv.st + vec2(266.0/(1280.0)/2.0));

 cc.r = rgb(p,q,h+(1.0/3.0));
 cc.g = rgb(p,q,h);
 cc.b = rgb(p,q,h-(1.0/3.0)); 

 cc/=4.0; 
 
 gl_FragColor = vec4(vec3(texture2D(tex, tex_coord.st))+cc.rgb,  1.0);
}

